#!/usr/local/bin/perl
#######################################################################
# (c) 2001 by Michael May     M&M Error Director v1.2
#  tmaster@bigfoot.com
# http://webmasters.winnfreenet.com   Check with website before using
#
#######################################################################

# Email to send a report to
$email = 'me@mydomain.com';

# Email report will be sent from
$fmail = 'mywebsite@mydomain.com';

# Enter a name for this website
$identify = "My Website Name";

# Path to your cgi directory.
# hypermart = /data1/hypermart.net/USERNAME/cgi-bin
# virtualave= /data1/virtualave.net/USERNAME/public_html/cgi-bin
# portland  = /home/USERNAME/cgi-bin
#
$logpath   =  "/yourpath-to-your-directory/cgi-bin";

# URL directory where your error pages are stored
$url_path  = "http://www.mydomain.com/error";

# Send mail search system. All of the listed paths will be checked for sendmail
# The first one that does not give a error will be used.
# If you know your sendmail path enter it on the first $mailer line. 

$mailer  = '/var/qmail/bin/qmail-inject';

$mailer1 = '/usr/sbin/sendmail';
$mailer2 = '/usr/lib/sendmail';
$mailer3 = '/usr/bin/sendmail';
$mailer4 = '/bin/sendmail';


$error401  = "401.html";
$error403  = "403.html";
$error404  = "404.html";
$error500  = "500.html";
$error000  = "hack.html";


# Full detailed logging 1=on 0=off   
$detail = '1';
# How many errors to save before sening email & reset
$rcount = "100";

# Email 1=on 0=off
$send_mail = "1";


&getdate;

$code_page = $error000 ;
$code = "Hack Atempt";
if ($ENV{'QUERY_STRING'} eq '401'){
         $code_page = $error401;
         $code = "Restricted Access";
         }
if ($ENV{'QUERY_STRING'} eq '403'){
         $code_page = $error403;
         $code = "No browsing";
         }
if ($ENV{'QUERY_STRING'} eq '404'){
         $code_page = $error404;
         $code = "File Not Found";
         }
if ($ENV{'QUERY_STRING'} eq '500'){
         $code_page = $error500;
         $code = "Failed Script";
         }
print "Status: 301 Found\n";
print "Location: $url_path/$code_page \n\n";


if (-s "$logpath/errorlog.txt") {
      &save_log;      
      }

else {
      &start_log;
      &save_log;
      }

if (-s "$logpath/errorlog2.txt") {
      &save_short_log;      
      }

else {
      &start_short_log;
      &save_short_log;
      }




&checkmail;

&count;


exit;



sub sendmail {


open (MAIL,"|$mail_program -t");
print MAIL "To: $email\n";
print MAIL "From: $fmail (Error log)\n";
print MAIL "Subject: Error LOG results: $identify\n";
print MAIL "X-Priority: 1 (Highest)\n\n";
print MAIL "The following is the error log to date. Last $num errors\n";

open (LOG, "$logpath/errorlog2.txt") ;
     @header = <LOG>;
     close (LOG);
        foreach $line (@header) {
        print MAIL "$line";
        }

print MAIL "-" x 75 . "\n\n";

open (LOG, "$logpath/errorlog.txt") ;
     @header = <LOG>;
     close (LOG);
        foreach $line (@header) {
        print MAIL "$line";
        }

print MAIL "-" x 75 . "\n\n";


&start_short_log;
&start_log;

$num ="0";
$num_day = $days[$wday];
close(MAIL);
}



sub count {

$num = "0";
$num_day ="Mon";

if (-s "$logpath/error-count.txt") {
      open (NUMBER, "<$logpath/error-count.txt")  ;
      $num = <NUMBER>;
      close (NUMBER);
}
else {open (NUMBER, ">>$logpath/error-count.txt") ; 
      print NUMBER $num;
      close (NUMBER);
      }

if (-s "$logpath/error-day.txt") {
      open (NUMBER, "<$logpath/error-day.txt")  ;
      $num_day = <NUMBER>;
      close (NUMBER);
}
else {open (NUMBER, ">>$logpath/error-day.txt") ; 
      print NUMBER $num_day;
      close (NUMBER);
      }

$num++;

if ($num > $rcount) {
     if ($num_day ne $days[$wday]){ 
              if ($send_mail) {
              &sendmail;
              }
              }
              }

open (NUMBER, ">$logpath/error-count.txt") ;
  	print NUMBER "$num";
   	close (NUMBER);

open (NUMBER, ">$logpath/error-day.txt") ;
  	print NUMBER "$num_day";
   	close (NUMBER);
}

sub save_short_log {

      open (LOG, ">>$logpath/errorlog2.txt") ;
	print LOG "Error : $code $ENV{'QUERY_STRING'} $ENV{'REDIRECT_URL'} \n";
      close (LOG);
}

sub start_short_log {

      open (NUMBER, ">$logpath/errorlog2.txt") ; 
      print NUMBER "Last $rcount errors for $identify\n";
      close (NUMBER);
}

sub start_log {

      open (NUMBER, ">$logpath/errorlog.txt") ; 
      print NUMBER "Last $rcount errors for $identify\n";
      close (NUMBER);

}

sub save_log {

      open (LOG, ">>$logpath/errorlog.txt") ;
	print LOG "Date  : $date \n";
	print LOG "Error : $code $ENV{'QUERY_STRING'} \n";
    	print LOG "Page  : $ENV{'REDIRECT_URL'} \n";
    	print LOG "URL   : $ENV{'REDIRECT_SCRIPT_URI'} \n";
    	print LOG "Cookie: $ENV{'HTTP_COOKIE'} \n";
	print LOG "HOST  : $ENV{'REMOTE_HOST'} \n";
	print LOG "IP    : $ENV{'REMOTE_ADDR'} \n"; 

if ($ENV{'HTTP_REFERER'}){
	    @terms = split(/\//,$ENV{'HTTP_REFERER'});
	    print LOG "From : $ENV{'HTTP_REFERER'} \n";
	   }

if ($detail){
      print LOG "More Details :\n\n";
      foreach $key (sort keys %ENV)
	        {print LOG "$key: $ENV{$key}\n";}
       }
     print LOG "-" x 75 . "\n\n";
     close(LOG);
}

sub getdate {

@days   = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
@months = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0,1,2,3,4,5,6];
	if ($hour < 12) {
          $am = "AM";
          if ($hour == 0) { $hour = 12; }
	    }
	elsif ($hour >= 12) {
		$hour -= 12; $am = "PM";
		if ($hour == 0) {
			$hour = 12;
		}
	}
	if ($min < 10) {
		$min = "0$min";
	}
	$time = $hour.":".$min." ".$am;

	if ($year < 95) {
	    $year += 2000;
	}
	else {
		$year += 1900;
	}
    $date = "$days[$wday], $months[$mon] $mday, $year at $time";
}





# Auto search for the sendmail

sub checkmail  {

if ( -e $mailer) {
    $mail_program=$mailer;
} elsif( -e $mailer1){
    $mail_program=$mailer1;
} elsif( -e $mailer2){
    $mail_program=$mailer2;
} elsif( -e $mailer3){
    $mail_program=$mailer3;
} elsif( -e $mailer4){
    $mail_program=$mailer4;
} else {
    $mail_program=""; $send_mail = "0"; 
}
}

